import DateTime
# CMF imports
from Products.CMFCore.utils import getToolByName

# plonetrackback imports
from Products.plonetrackback.interfaces import ITrackbackOutManager


def moveToWeblogRoot(self, info):
    o = info.object
    weblog = getToolByName(self, 'quills_tool').getParentWeblog(self)
    origin = o.aq_parent

    o_id = o.getId()
    weblog.manage_pasteObjects( origin.manage_cutObjects(o_id) )

    new = getattr(weblog, o_id)
    raise info.ObjectMoved(new, new)


def moveToArchive(self, info):
    o = info.object
    q_tool = getToolByName(self, 'quills_tool')

    weblog = q_tool.getParentWeblog(self)
    origin = o.aq_parent
    archive = getattr(weblog, 'archive')

    effective_date = o.EffectiveDate()
    if not effective_date:
        effective_date = DateTime.DateTime()
    if effective_date == 'None':
        # Don't ask
        effective_date = DateTime.DateTime()
    dest = archive.createPath(effective_date)

    o_id = o.getId()
    dest.manage_pasteObjects( origin.manage_cutObjects(o_id) )

    new = getattr(dest, o_id)

    # Send trackback pings if they are there
    # XXX The call to tbom.sendTrackbacks causes a ConflictError, and I
    # don't understand why.  It works fine when not called here i.e. during
    # a workflow transition.  This change effectively means that you have
    # to explicitly send trackbacks yourself *after* clicking "publish" (so
    # that the URL you are trackbacking to gets the correct URL for the
    # weblog entry.
    #tbom = ITrackbackOutManager(new)
    #tbom.sendTrackbacks()

    raise info.ObjectMoved(new, new)

