## Script (Python) "getCloud"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Return the proper set of Weblog Entries based on subpath
##

#Get the parent weblog
weblog = context.quills_tool.getParentWeblog(context)

#Get a list of topics, sorted alphabetically
topics = weblog.getCategories()
    
if not topics:
    return []

#Create a list of entries for each topic
topic_size = []
for topic in topics:
    topic_size.append(  len(topic) )

#Find the Min and Max number entries
min_topic_size = min(topic_size)
max_topic_size = max(topic_size)
# Make sure size_topic_size is never 0, or we get ZeroDivisionError later
size_topic_size = max_topic_size - min_topic_size + 0.0 or 1

#Create a lists to return tuples containing the topic object
#the relative weight of the topic, 0.0 to 1.0
#and the number of entries for that topic, since we already calculated it
#skip topics that have no entries.
result = []
for topic, number_of_entries in zip(topics, topic_size):
    if number_of_entries > 0:
        #Normalize the result
        rel = ( (number_of_entries - min_topic_size ) / 
                size_topic_size )
        #Add the result
        result.append( [topic, rel, number_of_entries] )
#Done...
return result
