"""
$Id:
"""
# Merges the init from LinguaPloneTestCase adn QuillsTestCase

from Testing import ZopeTestCase
try:
    from zope.app.testing import setup
except ImportError:
    from zope.app.tests import setup
from Products import Five
from Products import Quills
from Products import plonetrackback
from Products import RPCAuth

# Make the boring stuff load quietly
ZopeTestCase.installProduct('CMFCore', quiet=1)
ZopeTestCase.installProduct('CMFDefault', quiet=1)
ZopeTestCase.installProduct('CMFCalendar', quiet=1)
ZopeTestCase.installProduct('CMFTopic', quiet=1)
ZopeTestCase.installProduct('DCWorkflow', quiet=1)
ZopeTestCase.installProduct('CMFActionIcons', quiet=1)
ZopeTestCase.installProduct('CMFQuickInstallerTool', quiet=1)
ZopeTestCase.installProduct('CMFFormController', quiet=1)
ZopeTestCase.installProduct('GroupUserFolder', quiet=1)
ZopeTestCase.installProduct('TextIndexNG2', quiet=1)
ZopeTestCase.installProduct('SecureMailHost', quiet=1)
ZopeTestCase.installProduct('CMFDynamicViewFTI', quiet=1)
ZopeTestCase.installProduct('CMFPlone')

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('PortalTransforms', quiet=1)
ZopeTestCase.installProduct('MimetypesRegistry', quiet=1)
ZopeTestCase.installProduct('PloneLanguageTool')

ZopeTestCase.installProduct('RPCAuth')
ZopeTestCase.installProduct('Quills')
ZopeTestCase.installProduct('plonetrackback')
ZopeTestCase.installProduct('fatsyndication')

# Make sure the dummy types are registered
from Products.LinguaPlone import examples
from Products.LinguaPlone.tests import dummy
ZopeTestCase.installProduct('LinguaPlone')

from Products.LinguaPlone.config import IS_PLONE_2_0
if IS_PLONE_2_0:
    ZopeTestCase.installProduct('ExtendedPathIndex')

from Products.CMFPlone.tests import PloneTestCase
from Products.LinguaPlone.tests import utils
from Testing.ZopeTestCase.utils import setupCoreSessions

PORTAL_NAME = 'plone_ml'
PRODUCTS = ['Archetypes', 'PloneLanguageTool', 'LinguaPlone', 'Quills']

PloneTestCase.setupPloneSite(id=PORTAL_NAME, products=PRODUCTS)

class QuillsLinguaPloneTestCase(PloneTestCase.PloneTestCase):

    def getPortal(self):
        return self.app[PORTAL_NAME]

    def addLanguage(self, language):
        self.portal.portal_languages.addSupportedLanguage(language)

    def setLanguage(self, language):
        request = self.app.REQUEST
        request['set_language'] = language
        self.portal.portal_languages.setLanguageBindings()

    class Session(dict):
        def set(self, key, value):
            self[key] = value

    def _setupCA(self):
        """Set up Five/component architecture."""
        setup.placefulSetUp()
        Five.zcml.load_config('meta.zcml', Five)
        Five.zcml.load_config('permissions.zcml', Five)
        Five.zcml.load_config('configure.zcml', Five.site)
        Five.zcml.load_config('configure.zcml', Quills)
        #Five.zcml.load_config('configure.zcml', basesyndication)
        #Five.zcml.load_config('configure.zcml', fatsyndication)
        Five.zcml.load_config('configure.zcml', plonetrackback)
        Five.zcml.load_config('configure.zcml', RPCAuth)

    def _setup(self):
        self._setupCA()
        PloneTestCase.PloneTestCase._setup(self)
        #these may conflict
        self.app.REQUEST['SESSION'] = self.Session()
        setupCoreSessions(self.app)
        


