from Testing import ZopeTestCase
try:
    from zope.app.testing import setup
except ImportError:
    from zope.app.tests import setup
from Products import Five
from Products import Quills
from Products import plonetrackback
from Products import RPCAuth

# Make the boring stuff load quietly
ZopeTestCase.installProduct('CMFCore', quiet=1)
ZopeTestCase.installProduct('CMFDefault', quiet=1)
ZopeTestCase.installProduct('CMFCalendar', quiet=1)
ZopeTestCase.installProduct('CMFTopic', quiet=1)
ZopeTestCase.installProduct('DCWorkflow', quiet=1)
ZopeTestCase.installProduct('CMFActionIcons', quiet=1)
ZopeTestCase.installProduct('CMFQuickInstallerTool', quiet=1)
ZopeTestCase.installProduct('CMFFormController', quiet=1)
ZopeTestCase.installProduct('GroupUserFolder', quiet=1)
ZopeTestCase.installProduct('ZCTextIndex', quiet=1)
ZopeTestCase.installProduct('CMFPlone')

ZopeTestCase.installProduct('Archetypes')
ZopeTestCase.installProduct('PortalTransforms', quiet=1)
ZopeTestCase.installProduct('MimetypesRegistry', quiet=1)

ZopeTestCase.installProduct('RPCAuth')
ZopeTestCase.installProduct('Quills')
ZopeTestCase.installProduct('plonetrackback')
ZopeTestCase.installProduct('fatsyndication')

from Products.CMFPlone.tests import PloneTestCase

PRODUCTS = ['Quills']

PloneTestCase.setupPloneSite(products=PRODUCTS)


class QuillsTestCase(PloneTestCase.PloneTestCase):

    class Session(dict):
        def set(self, key, value):
            self[key] = value

    def _setupCA(self):
        """Set up Five/component architecture."""
        setup.placefulSetUp()
        Five.zcml.load_config('meta.zcml', Five)
        Five.zcml.load_config('permissions.zcml', Five)
        Five.zcml.load_config('configure.zcml', Five.site)
        Five.zcml.load_config('configure.zcml', Quills)
        #Five.zcml.load_config('configure.zcml', basesyndication)
        #Five.zcml.load_config('configure.zcml', fatsyndication)
        Five.zcml.load_config('configure.zcml', plonetrackback)
        #Five.zcml.load_config('configure.zcml', RPCAuth)

    def _setup(self):
        self._setupCA()
        PloneTestCase.PloneTestCase._setup(self)
        self.app.REQUEST['SESSION'] = self.Session()


class QuillsFunctionalTestCase(ZopeTestCase.Functional, QuillsTestCase):
    """Class for functional tests."""


