"""
$Id: test_weblog.py 27179 2006-08-14 00:03:21Z tim2p $
"""

import os, sys
if __name__ == "__main__":
    execfile(os.path.join(sys.path[0], "framework.py"))

from Testing import ZopeTestCase
from Products.Quills.tests import QuillsTestCase

from Products.Quills import config


class TestWeblog(QuillsTestCase.QuillsTestCase):

    def afterSetUp(self):
        self.login()
        self.setRoles(["Manager"])
        self.folder.invokeFactory("Weblog", id="weblog", title="Test Weblog")
        self.weblog = getattr(self.folder, "weblog")

    def testInitializeArchetype(self):
        archive = getattr(self.weblog, "archive")
        self.failUnless(archive.Title() == "Archive")

    def testGetTopics(self):
        self.failUnless(len(self.weblog.getTopics()) == 0)
        #self.assertEquals(
        #        [topic.Title() for topic in self.weblog.getTopics()],
        #        ['General',])

        # Make sure we only get WeblogTopics back
        self.weblog.invokeFactory('WeblogEntry', id='test-entry',
                title="Test Entry")
        entry = self.weblog['test-entry']
        subjects = ['Keyword1', 'keyword2']
        entry.setSubject(subjects)
        # Ack, weblog.getTopics relies on a catalog query...
        entry.reindexObject()
        topic_ids = [topic.title_or_id() for topic in self.weblog.getTopics()]
        # assertEquals cares about the order of keywords in the list!
        topic_ids.sort()
        subjects.sort()
        self.assertEquals(topic_ids, subjects)

    def testRPCBlogging(self):
        self.failUnless( hasattr(self.weblog.aq_explicit, 'metaWeblog') )
        self.failUnless( hasattr(self.weblog.aq_explicit, 'blogger') )


def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestWeblog))
    return suite

if __name__ == '__main__':
    framework()
