"""
$Id: test_weblogentry.py 26895 2006-08-07 17:02:58Z tim2p $
"""

import os, sys
if __name__ == "__main__":
    execfile(os.path.join(sys.path[0], "framework.py"))

from Testing import ZopeTestCase
from Products.Quills.tests import QuillsTestCase

from Products.Quills import config


class TestWeblogEntry(QuillsTestCase.QuillsTestCase):

    def afterSetUp(self):
        self.login()
        self.setRoles(["Manager"])
        self.folder.invokeFactory("Weblog", id="weblog", title="Test Weblog")
        self.weblog = getattr(self.folder, "weblog")
        self.weblog.invokeFactory("WeblogEntry", "entry")
        entry = self.weblog.entry
        entry.setTitle("Test Entry")
        self.entry = entry

    def testEntry(self):
        #from Products.CMFCore import CMFCorePermissions
        self.assertEquals(self.entry.getId(), "entry")
        self.assertEquals(self.entry.Title(), "Test Entry")

    def testSchema(self):
        from Products.Quills.WeblogEntry import WeblogEntrySchema
        self.assertEquals(self.entry.schema, WeblogEntrySchema)

    def testTypeInfo(self):
        self.assertEquals(self.entry.archetype_name, "Weblog Entry")
        self.assertEquals(self.entry.meta_type, 'WeblogEntry')
        self.assertEquals(self.entry.content_icon, 'weblogentry_icon.gif')
        self.assertEquals(self.entry.global_allow, False)

    def testViews(self):
        self.assertEquals(self.entry.default_view, 'weblogentry_view')
        self.assertEquals(self.entry.immediate_view, 'weblogentry_view')
        self.assertEquals(self.entry.schema['id'].widget.visible,
                          {'view': 'invisible'})
        self.failUnless(self.entry.start() == self.entry.end(),
                        "start and end should be the same")

    def testAllowDiscussion(self):
        # By default, Quills should use the default setting for allowing
        # discussion or not from the portal_types tool.
        # Check that the schema default is correct
        self.assertEquals(self.entry.schema['allowDiscussion'].default,
                          None)
        # Check that the actual instance attribute is also correct
        allow_discussion = getattr(self.entry.aq_explicit,
                                   'allow_discussion',
                                   None)
        self.failUnlessEqual(allow_discussion, None)



    def testEntryCategories(self):
        entry = getattr(self.weblog, "entry")
        cats = [cat for cat in entry.getCategories()]
        self.failUnlessEqual(cats, [])


    # Trackback tests now live in plonetrackback.tests
    #def testEntryTrackbacks(self):



def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestWeblogEntry))
    return suite

if __name__ == '__main__':
    framework()
