# Standard library imports
from cStringIO import StringIO


def grantViewTrackbacksToAnon(portal, out=None):
    """Give Anonymous the 'plonetrackback: View Trackbacks' permission.
    """
    perm = "plonetrackback: View Trackbacks"
    # Get hold of the existing roles for our permission
    roles = portal.rolesOfPermission(perm)
    # roles looks like this:
    # [{'selected': 'SELECTED', 'name': 'Anonymous'},
    #  {'selected': '', 'name': 'Authenticated'},]
    roles_list = [role['name'] for role in roles]
    # Don't do anything if we don't need to
    if "Anonymous" in roles_list:
        if out is not None:
            msg = "'Anonymous' already has the '%s' permission at the portal root so no action taken."
            print >> out, msg % perm
        return
    # Add "Anonymous" to the roles list
    roles_list.append("Anonymous")
    # Update with the new roles list
    portal.manage_permission(perm,
                             roles=roles_list,
                             acquire=1)
    if out is not None:
        msg = "Granted 'Anonymous' the '%s' permission at the portal root."
        print >> out, msg % perm


def install(self):
    """Install plonetrackback.
    """
    out = StringIO()

    grantViewTrackbacksToAnon(self, out)

    return out.getvalue()
