# Standard library imports
import re, os

# Product imports
from Products.plonetrackback.errors import BlacklistedURL

# Gets populated at import time by the code under if not REGEXPS
REGEXPS = []

def _parseLine(line):
    parts = line.split('#')
    pattern = parts[0].strip()
    return re.compile(pattern)

# Only populate REGEXPS once
if not REGEXPS:
    txtpath = os.path.join( os.path.dirname(__file__), 'mt_blacklist.txt' )
    fp = file(txtpath, 'r')
    for line in fp:
        line = line.strip()
        if line and not line.startswith('#'):
            REGEXPS.append( _parseLine(line) )
    del fp


def checkTrackback(trackback):
    url = trackback.getURL()
    for regexp in REGEXPS:
        match = regexp.search(url)
        if match:
            raise BlacklistedURL(url, match)

