import os, sys
if __name__ == "__main__":
    execfile(os.path.join(sys.path[0], "framework.py"))

from Testing import ZopeTestCase
from Products.plonetrackback.tests import PloneTrackbackTestCase

from Products.plonetrackback.interfaces import ITrackback, ITrackbackStore
from Products.plonetrackback.trackback import Trackback


class TestTrackback(PloneTrackbackTestCase.PloneTrackbackTestCase):

    def afterSetUp(self):
        self.setRoles(["Manager"])
        self.folder.invokeFactory("Document", id="test_page", title="Test Page")
        self.document = getattr(self.folder, "test_page")

    def testTrackbacks(self):
        tbstore = ITrackbackStore(self.document)
        # No trackback pings to start with
        self.failUnlessEqual(tbstore.getTrackbacks(), [])

        # Create a trackback...
        tbdict = {  'title'      : 'Trackback Title'
                  , 'url'        : 'http://example.com/'
                  , 'excerpt'    : 'The excerpt of the post.'
                  , 'site_title' : 'Trackback Test Site'
                 }
        tb = Trackback(**tbdict)
        # Store the trackback...
        tbstore.storeTrackback(tb)
        # Retrieve the new trackback
        tbs = tbstore.getTrackbacks()
        tb0 = tbs[0]
        self.failUnless(tb0.getTitle() == tbdict['title'])
        self.failUnless(tb0.getURL() == tbdict['url'])
        self.failUnless(tb0.getExcerpt() == tbdict['excerpt'])
        self.failUnless(tb0.getSiteTitle() == tbdict['site_title'])



def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestTrackback))
    return suite

if __name__ == '__main__':
    framework()
