# Zope 2 imports
import zLOG

# zope 3 imports
from zope.interface import implements
from zope.app.annotation.interfaces import IAnnotations, IAnnotatable
from persistent.list import PersistentList
from persistent.mapping import  PersistentMapping

# CMF imports
from Products.CMFCore.utils import getToolByName

# Product imports
from interfaces import ITrackbackOutManager #, ITrackbackSender
from trackback import Trackback
from config import PROJECTNAME

# Standard library imports
import urllib, urllib2


TRACKBACK_KEY = 'plonetrackback.sender'


class TrackbackOutManagerAnnotations:
    """Adapter to manage outgoing trackbacks using IAnnotations.
    """

    implements(ITrackbackOutManager)
    __used_for__ = IAnnotatable

    def __init__(self, context):
        self.context = context
        self.annotations = IAnnotations(context)
        self.trackouts = self.annotations.get(TRACKBACK_KEY, None)
        if self.trackouts is None:
            self.annotations[TRACKBACK_KEY] = PersistentMapping()
            self.trackouts = self.annotations[TRACKBACK_KEY]
            self.trackouts['unsent'] = PersistentList()
            self.trackouts['sent'] = PersistentList()
    
    def getTitle(self):
        """See ITrackbackOutManager.
        """
        return self.context.Title()

    def getExcerpt(self):
        """See ITrackbackOutManager.
        """
        return self.context.Description()

    def getURL(self):
        """See ITrackbackOutManager.
        """
        return self.context.absolute_url()

    def getSiteTitle(self):
        """See ITrackbackOutManager.
        """
        po = getToolByName(self.context, 'portal_url').getPortalObject()
        return po.Title()

    def getURLsToPing(self):
        """See ITrackbackOutManager.
        """
        # Return a copy of the persistent list
        unsent = []
        for url in self.trackouts['unsent']:
            unsent.append(url)
        return unsent

    def setURLsToPing(self, urls):
        """See ITrackbackOutManager.
        """
        unsent = PersistentList()
        unsent.extend(urls)
        self.trackouts['unsent'] = unsent

    def getPingedURLs(self):
        """See ITrackbackOutManager.
        """
        # Return a copy of the persistent list
        sent = []
        for url in self.trackouts['sent']:
            sent.append(url)
        return sent

    def setPingedURLs(self, urls):
        """See ITrackbackOutManager.
        """
        sent = PersistentList()
        sent.extend(urls)
        self.trackouts['sent'] = sent

    def sendTrackbacks(self):
        """See ITrackbackOutManager.
        """
        data = {}
        data['title'] = self.getTitle()
        data['excerpt'] = self.getExcerpt()
        data['url'] = self.getURL()
        data['blog_name'] = self.getSiteTitle()
        succeeded = []
        failed = []
        for url in self.getURLsToPing():
            try:
                try:
                    f = urllib2.urlopen(url, urllib.urlencode(data))
                    succeeded.append(url)
                except urllib2.HTTPError, e:
                    # Catch HTTPErrors as at least one sort is ok
                    if e.code == 204:
                        # 204 means 'No content' returned, which is fine
                        succeeded.append(url)
                    else:
                        # If it wasn't an ok sort, re-raise to be caught by the outer handler
                        raise
            except Exception, e:
                zLOG.LOG(PROJECTNAME, zLOG.INFO, '', 'Failed trackback ping to %s: %s' % (url, str(e)) )
                failed.append(url)
        self.setURLsToPing(failed)
        pinged = self.getPingedURLs()
        pinged.extend(succeeded)
        self.setPingedURLs(pinged)
